#ifndef __JOYSTICK_H__
#define __JOYSTICK_H__

#ifdef USE_JOYSTICK 

#ifdef ASSEMBLER

#define joy_left    $01
#define joy_right   $02
#define joy_down    $08
#define joy_up      $10
#define joy_button  $20

#else

#define joy_left    0x01
#define joy_right   0x02
#define joy_down    0x08
#define joy_up      0x10
#define joy_button  0x20

extern unsigned char joy_present;
extern unsigned char joy_1;
extern unsigned char joy_2;

/*
 * ALTAI Joystick
 */
#ifdef USE_JOYSTICK_ALTAI

void altai_detect(void);
void altai_read(void);

#endif /* USE_JOYSTICK_ALTAI */

/*
 * IJK Joystick
*/
#ifdef USE_JOYSTICK_IJK

void ijk_detect(void);
void ijk_read(void);

#endif /* USE_JOYSTICK_IJK */

#endif /* ASSEMBLER */

#endif /* USE_JOYSTICK */

#endif /* __JOYSTICK_H__ */
