;=================================================
; Joystick for Oric

#ifdef USE_JOYSTICK 
#include <via.h>

.text

_joy_present  .byt  0

_joy_1        .byt  0
_joy_2        .byt  0


;=================================================
; ALTAI Joystick
;=================================================
#ifdef USE_JOYSTICK_ALTAI

_altai_detect
            lda #0
            sta _joy_present
            sta _joy_1
            sta _joy_2
            
            ; always present
            inc _joy_present
            rts
            
            
_altai_read
            php
            sei

            lda via_a
            pha
            lda via_ddra
            pha
            lda #$c0
            sta via_ddra
            lda #$80
            sta via_aor
            lda via_aor
            eor #$ff
            sta _joy_1
            lda #$40
            sta via_aor
            lda via_a
            eor #$ff
            sta _joy_2
            pla
            sta via_ddra
            pla
            sta via_a

            plp
            rts

#endif

;=================================================
; IJK Joystick
;=================================================
#ifdef USE_JOYSTICK_IJK

ijk_bits
          .byt 0,2,1,3,32,34,33,0,8,10,9,0,40,42,41,0
          .byt 16,18,17,0,48,50,49,0,0,0,0,0,0,0,0,0

ijk_prepare
          ;ensure printer strobe is set to output
          lda #%10110111
          sta via_ddrb

          ;set strobe low
          lda #%00000000
          sta via_b

          ;set top two bits of porta to output and rest as input
          lda #%11000000
          sta via_ddra
          rts

_ijk_detect
          php
          sei
          jsr ijk_prepare

          lda #%11000000
          sta via_a

          lda via_a
          and #%00100000
          eor #%00100000
          sta _joy_present

          ; beq ijk_absent
          ; bne ijk_present

          ;restore via porta state
          lda #%11111111
          sta via_ddra
          plp
          rts

_ijk_read
          php
          sei
          jsr ijk_prepare

          ;select left joystick
          lda #%01111111
          sta via_a
          ;read back left joystick state
          lda via_a
          ;mask out unused bits
          and #%00011111
          ;invert bits
          eor #%00011111
          ;index table to conform to generic format
          tax
          lda ijk_bits,x
          sta _joy_1

          ;select right joystick
          lda #%10111111
          sta via_a
          ;read back right joystick state and rejig bits
          lda via_a
          and #%00011111
          eor #%00011111
          tax
          lda ijk_bits,x
          sta _joy_2
          
          ;restore via porta state
          lda #%11111111
          sta via_ddra
          plp
          rts
#endif

#endif
